procedure page_03;

const
  EMMint = $67;
  qEMMdrvr = 'EMMXXXX0';

var
  EMMarray : array[$000..$3FF] of word;
  xlong : longint;
  xword1 : word;
  xword2 : word;
  xstring : string;
  EMMver, j: byte;
  EMMname: array[1..8] of char;

procedure EMMerr(a : byte);

begin
  case a of
    $80 : writeln('internal error in EMM software');
    $81 : writeln('malfunction in expanded memory hardware');
    $82 : writeln('memory manager busy');
    $83 : writeln('invalid handle');
    $84 : writeln('undefined function');
    $85 : writeln('no more handles available');
    $86 : writeln('error in save or restore of mapping context');
    $87 : writeln('not enough physical pages available');
    $88 : writeln('not enough free pages available');
    $89 : writeln('no pages requested');
    $8A : writeln('logical page outside range assigned to handle');
    $8B : writeln('invalid physical page number');
    $8C : writeln('page map hardware state save area full');
    $8D : writeln('mapping context already in save area');
    $8E : writeln('mapping context not in save area');
    $8F : writeln('undefined subfunction parameter')
    else
      unknown('expanded memory error', a, 2)
  end
end;

  begin (* procedure page_03 *)
  caption2('Total conventional memory (bytes)');
  writeln(DOSmem : 6);
  caption2('Free conventional memory (bytes) ');
  writeln(DOSmem - longint(prefixseg) shl 4 : 6);
  caption2('Extended memory (from BIOS)    ');
  with regs do begin
    AH:=$88;
    intr($15, regs);
    if nocarry then
      writeln(longint(AX) shl 10 : 8)
    else
      writeln('     N/A')
  end;
  caption2('XMS driver present ');
  with regs do
    begin
    AX:=$4300;
    Intr($2F, regs);
    if AL <> $80 then
      Writeln('no')
    else
      begin
      Writeln('yes');
      AX:=$4310;
      Intr($2F, regs);
      xword1:=ES;
      xword2:=BX;
      end
    end;
  caption2('DPMI driver present');
  with regs do
    begin
    AX:=$1687;
    Intr($2F, regs);
    if AL <> 0 then
      Writeln('no')
    else
      begin
      Writeln('yes');
      caption3('version');
      Write(DH, Chr(country[9]), DL);
      caption3('CPU');
      case CL of
        2: Write('286');
        3: Write('386');
        4: Write('486')
      else
        Write('???')
      end;
      caption3('switch mode entry');
      segofs(ES, DI);
      Writeln
      end
    end;
  caption2('Expanded memory');
  if longint(intvec[EMMint]) <> $00000000 then
    begin
    writeln;
    caption3('Interrupt vector');
    xlong:=longint(intvec[EMMint]);
    xword1:=xlong shr 16;
    xword2:=xlong and $0000FFFF;
    segofs(xword1, xword2);
    writeln;
    caption3('Driver');
    xstring:='';
    for i:=$000A to $0011 do
      xstring:=xstring + showchar(chr(mem[xword1 : i]));
    write(xstring);
    if xstring = qEMMdrvr then
      begin
      writeln;
      caption3('Manager status');
      with regs do
        begin
        AH:=$40;
        intr(EMMint, regs);
        if AH = $00 then
          writeln('OK')
        else
          EMMerr(AH);
        caption3('Page frame segment');
        AH:=$41;
        intr(EMMint, regs);
        if AH = $00 then
          writeln(hex(BX, 4))
        else
          EMMerr(AH);
        caption3('Total EMS memory (16K pages)');
        AH:=$42;
        intr(EMMint, regs);
        if AH = $00 then
          writeln(DX : 3)
        else
          EMMerr(AH);
        caption3('Free EMS memory (16K pages) ');
        if AH = $00 then
          writeln(BX : 3)
        else
          EMMerr(AH);
        caption3('EMM version');
        AH:=$46;
        intr(EMMint, regs);
        if AH = $00 then
          writeln(AL shr 4, Chr(country[9]), AL and $0F)
        else
          EMMerr(AH);
        EMMver:=AL shr 4;
        if EMMver >= 4 then
          begin
          caption3('VCPI capable');
          {must make sure 1 page is allocated to be sure that EMS}
          {driver is ON. VCPI is not detectable if EMS driver is OFF}
          {16K of EMS needed for this test to work properly}
          AH:=$43;
          BX:=1;
          Intr(EMMint, regs);
          if AH <> 0 then
            Writeln('error: need 16K available EMS to detect')
          else
            begin
            xword1:=DX; {handle}
            AX:=$DE00;
            Intr(EMMint, regs);
            if AH <> 0 then
              Writeln('no')
            else
              begin
              Write('yes');
              caption3('VCPI version');
              Writeln(BH, Chr(country[9]), BL);
              end;
            AH:=$45; {release our handle}
            DX:=xword1;
            Intr(EMMint, regs)
            end
          end;
        caption1('  Handle   16K pages  Name');
        writeln;
        AH:=$4D;
        ES:=seg(EMMarray);
        DI:=ofs(EMMarray);
        intr(EMMint, regs);
        if AH = $00 then
          if BX > $0000 then
            begin
            window(3, wherey + hi(windmin), twidth, tlength - 2);
            for i:=1 to BX do
              begin
              pause2;
              if endit then
                Exit;
              write(hex(EMMarray[2 * i - 2], 4), '     ',
                EMMarray[2 * i - 1] : 3, '        ');
              if EMMver >= 4 then
                begin
                AX:=$5300;
                DX:=EMMarray[2 * i - 2];
                ES:=Seg(EMMname);
                DI:=Ofs(EMMname);
                Intr(EMMint, regs);
                if AH = 0 then
                  for j:=1 to 8 do
                    if EMMname[j] <> #0 then
                      Write(EMMname[j]);
                end;
              Writeln;
              end
            end
          else
            writeln('  (no active handles)')
        else
          EMMerr(AH)
        end
      end
    else
      dontknow
    end
  else
    writeln('(none)')
  end;
